/* Kishimot's Memo viewer ver 0.17 */

#ifdef JCURSES
#include <jcurses.h>
#endif
#ifdef NCURSES
#include <ncurses.h>
#endif

#include <curses.h> 
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <malloc.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define READ_F ((unsigned short) 04)
#define WRIT_F ((unsigned short) 02)
#define EXEC_F ((unsigned short) 01)


#define STRSIZ 65535
#define MAXGNLTH 32

#define PgUP 1
#define PgDOWN 2
#define CURUP 3
#define CURDOWN 4
#define CURLEFT 5
#define CURRIGHT 6
#define F1 7
#define F2 8
#define F3 9
#define SHIFT0 '~'
#define SHIFT1 '!'
#define SHIFT2 '"'
#define SHIFT3 '#'
#define SHIFT4 '$'
#define SHIFT5 '%'
#define SHIFT6 '&'
#define SHIFT7 '\''
#define SHIFT8 '('
#define SHIFT9 ')'

#define RETRIEVE 0
#define TIMEATTR 1
#define LASTTIME 2
#define ALPHA 3

#define GROUPMAX 16
#define ITEMMAX 512
#define WINMAX 64
#define SEPA "^@_^\n"
#define SEPA2 "-=-=-=-\n"

typedef struct{
	int id;
	int line;
	int width;
	char *string;
	int w;
	int n;
	int b;
	int time;
	time_t ltime;
	int mode;
} Item;

typedef struct{
	char name[MAXGNLTH];
} Group;

typedef struct{
	Item *it;
	int x;
	int y;
	int maxy;
} MyWin;

Item *item[ITEMMAX];
Item *view[ITEMMAX];
Item **arr;
Item yankb;
int siori[10];
int wori=0;
char ybstr[STRSIZ];

MyWin wins[WINMAX];
Group group[GROUPMAX];

int maxinum = 0;
int maxgnum = 0;
int maxid = 0;
int curi = 0;
int curw = 0;
int maxw = 0;
int curg = 0;
int crgrp = 0;
int retflag = 1;
int ok =-1;
int XSIZE = 79;
int YSIZE = 23;
char *editor;
char *rootDir,groupname[64];

char *helpall1 = "kmview 0.17 Help\n\nڰưɽ\n j,z,,F2ļ\n k,a,,F1\n n,],PgUpļڡ\n p,[,PgDnڡ\n CR,SP,F3lessɽ\n v,ejvimԽ\n \nڥκȺ\n NĿ\n Rĥκ\n Cĥʣ\n YİХåեYank\n PİХåեPut\n +ĥη\n\nڥ롼ס\n Bĥ롼׺\n G̥롼פɤ\n\nڽλ\n qĥǥ˽񤭹߽λ\n Xĥǥ˽񤭹ޤλ\n Wĥǥ˽񤭹\n\nڥν\n M̤Υ롼פذư\n Uľذư\n DĲذư\n <Ƭذư\n >ذư\n\n";
char *helpall2 = "ڥ°\n ^WĽ°ȥ\n ^Xļ¹°ȥ\n \nڥμ¹ԡ\n Eĥ륹ץȼ¹\n \nڥ֡\n H򶹤\n JĹԤ䤹\n KĹԤ򸺤餹\n L䤹\n {10餹\n }10䤹\n\n oĥȤνŤ͹碌ȥ\nڸ\n /ĥ򥭡˸ \n\nڥȡ\n T°ղ\n t°ǵս祽\n lĺǽդǵս祽\n sļ祽\n\n١\n 0Ƭذư\n 19٤Ͽ˰ư\n SHIFT+0ĸߤΥ٤ξõ\n SHIFT+19ĸߤΥ٤Ͽ\n\nڥإס\n ?ܥåɽ\n "; 
char *helpsort = "kmview 0.17 Help(sort mode)\n\nڰưɽ\n j,z,,F2ļ\n k,a,,F1\n n,],PgUpļڡ\n p,[,PgDnڡ\n CR,SP,F3lessɽ\n v,ejvimԽ\n\nڥʣ\n YİХåեYank\n\nڽλ\n qsortɽλ\n\nڥν\n ZĥȽ¸\n\nڥإס\n ?ܥåɽ\n";

int
mygetch(){
	char c;
	c = getch();
	if(c == ''){
		c = getch();
		if(c == '['){
			c = getch();
			if(c == 'A') c = CURUP;
			else if(c == 'B') c = CURDOWN;
			else if(c == 'C') c = CURRIGHT;
			else if(c == 'D') c = CURLEFT;
			else if(c == '5') {
				c = getch();
				if(c == '~') c=PgUP;
			}else if(c == '6') {
				c = getch();
				if(c == '~') c=PgDOWN;
			}
			else if(c == '[') {
				c = getch();
				if(c == 'A') c=F1;
				if(c == 'B') c=F2;
				if(c == 'C') c=F3;
			}
		}
	}
	return c;
}

char *
cutLine(char *buf,int size){
	int i;

	i=0;
	while(1){
		if(buf[i]=='\0') break;
		if (((unsigned char)buf[i] & 0x80) != 0) i++;
		i++;
		if(i>=size) {
			buf[i]='\0';
			break;
		}
	}
	return buf;
}

void
crLock(){
	char lockf[256];
	FILE *fp;

	sprintf(lockf,"%s/.kmviewLock",getenv("HOME"));
	if(NULL != (fp=fopen(lockf,"r"))){
		fprintf(stderr,"~/.kmviewLock already exists.\n");
		exit(1);
	}
	creat(lockf,S_IRWXU);
}

void
delLock(){
	char lockf[256];
	sprintf(lockf,"%s/.kmviewLock",getenv("HOME"));
	remove(lockf);
}

void
getGroup(){
	DIR *dp;
	struct direct *dir;
	int filenum,i,ngflag;
	char buf[8];

	curg=0;
	if((dp=opendir(rootDir))==NULL){
		fprintf(stderr,"can't open root: %s\n",rootDir);
		closedir(dp);
		delLock();
		exit(1);
	}

	while((dir = readdir(dp))!= NULL){
		if(dir->d_ino ==0) continue;
		if(strcmp(dir->d_name,"..")==0) continue;
		if(strcmp(dir->d_name,".")==0) continue;

		strcpy(group[curg].name,dir->d_name);
		curg++;
	}
	maxgnum=curg;
	curg=0;
	closedir(dp);
	if(maxgnum==0) { creategroup("base"); return; }

	if(strcmp(group[0].name,"base")==0) return;

	strcpy(buf,group[0].name);
	strcpy(group[0].name,"base");

	ngflag=0;
	for(i=1;i<maxgnum;i++){
		if(strcmp(group[i].name,"base")==0) {
			strcpy(group[i].name,buf);
			ngflag=1;
		}
	}
	if(ngflag==0) creategroup("base");
}

int
sgets(char *buf,int size,char *string){
	int i=0;

	while('\0' != string[i]){
		buf[i]=string[i];
		if(string[i]=='\n'){
			buf[i]='\0';
			return i+1;
		}else if(i>=size-2){
			buf[i+1]='\0';
			return i+1;
		}
		i++;
	}
	buf[i]='\0';
	return i;
}

void
fileRead(char *fn){
	FILE *fp;
	char buf[STRSIZ],its[STRSIZ];
	int i,n,maxw;

	if(NULL==(fp=fopen(fn,"r"))){ fprintf(stderr,"%s not found\n",fn); exit(0);}

	curi = 0;

	for(i=0;i<10;i++) siori[i]=0;
	fgets(buf,BUFSIZ,fp);
	sscanf(buf,"%d %d %d %d %d %d %d %d %d",
	siori+1,siori+2,siori+3,siori+4,siori+5,siori+6,siori+7,siori+8,siori+9);

	i=maxw=0;
	its[0]=buf[0]='\0';
	while(NULL != fgets(buf,BUFSIZ,fp)){
		if(0==strcmp(buf,SEPA)){
			if(NULL==(item[i]=malloc(sizeof(Item)))){
				fprintf(stderr,"no malloc3 \n"); exit(0); }
			fgets(buf,BUFSIZ,fp);
			sscanf(buf,"%d %d %d %d %d", &(item[i]->width), &(item[i]->line), &(item[i]->time), &(item[i]->ltime), &(item[i]->mode));
			if(item[i]->width> XSIZE-3) item[i]->width = XSIZE-4;
			if(item[i]->line>  YSIZE-3) item[i]->line  = YSIZE-4;
			item[i]->string=strdup(its);
			item[i]->id=i+1;
			item[i]->b=strlen(its);
			item[i]->n=n;
			item[i]->w=maxw;
			n=0;
			maxw=0;
			i++;
			its[0]='\0';
		}else{
			if(maxw<strlen(buf))maxw=strlen(buf);
			strcat(its,buf);
			n++;
		}
	}
	fclose(fp);
	maxinum=i;
	maxid=i+1;
}

void
readItems(char *fn){
	char buf[128];
	int i=0;

	strcpy(groupname,fn);
	if(crgrp==1){
		for(i=0;i<10;i++) siori[i]=0;
		curi = 0;

		if(NULL==(item[0]=malloc(sizeof(Item)))){
				fprintf(stderr,"no malloc3 \n"); exit(0); }
		item[0]->width=10;
		item[0]->line=5;
		item[0]->time=0;
		item[0]->ltime=time(NULL);
		item[0]->mode=6;
		item[0]->string=strdup("New\n");
		item[0]->id=1;
		item[0]->b=4;
		item[0]->n=1;
		item[0]->w=4;
		maxinum=1;
		maxid=2;

		crgrp=0;
	}else{
		sprintf(buf,"%s/%s",rootDir,fn);
		fileRead(buf);
	}
}

void
winInit(){
	int i;
	initscr();
	cbreak(); noecho(); nonl();
	clear();
	XSIZE=tgetnum("co")-1;
	YSIZE=tgetnum("li")-1;
}

void
winEnd(){
	nocbreak(); echo(); nl();
	endwin();
}

void
fileWrite(char *fn){
	FILE *fp;
	int i,j;
	int sr[10];

	if(NULL==(fp=fopen(fn,"w"))){ fprintf(stderr,"%s not open\n",fn); exit(0);}

	for(i=0;i<10;i++) sr[i]=0;

	for(i=0;i<maxinum;i++)
		for(j=1;j<10;j++)
			if(item[i]->id==siori[j]) sr[j]=i+1;

	for(i=1;i<10;i++)
		fprintf(fp,"%d ",sr[i]);

	fprintf(fp,"\n");
	for(i=0;i<maxinum;i++){
		fprintf(fp,"%s",item[i]->string);
		fprintf(fp,"%s",SEPA);
		fprintf(fp,"%d %d %d %d %d\n",item[i]->width,item[i]->line,item[i]->time, item[i]->ltime, item[i]->mode);
	}
	fclose(fp);
}

void
writeItems(char *fn){
	char buf[128];

	sprintf(buf,"%s/%s",rootDir,fn);
	fileWrite(buf);
}

void
freeItems(){
	int i;

	for(i=0;i<maxinum;i++){
		free(item[i]->string);
		free(item[i]);
	}
}

void
copyItem(Item *to,Item *from){
	to->id=from->id;
	to->line=from->line;
	to->width=from->width;
	to->string=strdup(from->string);
	to->time=from->time;
	to->ltime=from->ltime;
	to->mode=from->mode;
	to->w=from->w;
	to->n=from->n;
	to->b=from->b;
}

void
swapItem(Item *i1,Item *i2){
   Item sw;
	copyItem(&sw,i1);
	copyItem(i1,i2);
	copyItem(i2,&sw);
}

void
mybox(int wid,char h,char v){
	int i;

	for(i=1; i< (wins[wid].it->width)+2; i++){
		move(wins[wid].y,wins[wid].x+i); 
		if((inch()==' ')||(inch()=='.')||(inch()=='=')) addch(h);
		move(wins[wid].y+(wins[wid].it->line)+2,wins[wid].x+i); addch(h);
	}
	for(i=1;i<(wins[wid].it->line)+2;i++){
		move(wins[wid].y+i,wins[wid].x); 
		if((inch()==' ')||(inch()==':')||(inch()=='|')) addch(v);
		move(wins[wid].y+i,wins[wid].x+(wins[wid].it->width)+2); addch(v);
	}
	move(wins[wid].y,wins[wid].x); 
		if((inch()==' ')||(inch()==':')||(inch()=='|') ||(inch()==':')||(inch()=='|')) addch('*');
	 move(wins[wid].y,wins[wid].x+(wins[wid].it->width)+2); 
		if((inch()==' ')||(inch()==':')||(inch()=='|') ||(inch()==':')||(inch()=='|')) addch('*');
	move(wins[wid].y+(wins[wid].it->line)+2,wins[wid].x); 
		if((inch()==' ')||(inch()==':')||(inch()=='|') ||(inch()==':')||(inch()=='|')) addch('*');
	 move(wins[wid].y+(wins[wid].it->line)+2,
	 	wins[wid].x+(wins[wid].it->width)+2); 
		if((inch()==' ')||(inch()==':')||(inch()=='|') ||(inch()==':')||(inch()=='|')) addch('*');

	if(wins[wid].it->time !=0){
	 	move(wins[wid].y,wins[wid].x+2); 
		printw("%4d/%02d/%02d",
		(wins[wid].it->time)/10000 , ((wins[wid].it->time)%10000)/100 ,
		((wins[wid].it->time)%10000)%100);
	}

	for(i=9;i>=0;i--){
		if((siori[i]== wins[wid].it->id) && (retflag==1)){
			move(wins[wid].y+(wins[wid].it->line)+2,wins[wid].x+2); 
			printw(">%d",i);
		}
	}
	if(wins[wid].it->w-1 > wins[wid].it->width){
		move(wins[wid].y+(wins[wid].it->line)+1,
			wins[wid].x+(wins[wid].it->width)+2); addch('#');
	}
	if(wins[wid].it->n-1 > wins[wid].it->line){
		move(wins[wid].y+(wins[wid].it->line)+2,
		wins[wid].x+(wins[wid].it->width)+1); addch('#');
	}
}

void
mytext(int wid){
	int j,sl;
	char *s,buf[BUFSIZ];

	s=wins[wid].it->string;
	sl=0;
	buf[0]='\0';
	for(j=0;j<wins[wid].it->line+1;j++){
		sl+=sgets(buf,BUFSIZ,&(s[sl]));
		cutLine(buf,wins[wid].it->width);
		move(wins[wid].y+1+j,wins[wid].x+1);
		printw("%s",buf);
	}
}

void
drawWindow(int wid,int x,int y,int maxy){
	wins[wid].x=x;
	wins[wid].y=y;
	wins[wid].maxy=maxy;
	mybox(wid,'.',':');
	mytext(wid);
}

int
checklayout(int num){
	int i,j,x,y,maxx,maxy,miny;

	j=0;

	while(1){
		i=j;
		x=y=0;
		maxy=miny=1;
		maxx=0;
		while(1){
			if(maxx+(arr[i]->width)+1+wori<=XSIZE){
				if(miny+(arr[i]->line)+2+wori<=YSIZE){
					maxx+=(arr[i]->width)+2+wori;
					if(miny+(arr[i]->line)+2+wori>maxy){ maxy=miny+(arr[i]->line)+2+wori; }
				}else{
					break;
				}
			} else {
				maxx=0;
				miny=maxy;
				if(miny+(arr[i]->line)+2+wori<=YSIZE){
					maxx=(arr[i]->width)+2+wori;
					maxy=miny+(arr[i]->line)+2+wori;
				}else{
					break;
				}
			}
			i++;
			if(maxinum<=i)break;
		}
		if(i>=num) break;
		j++;
	}
	return j;
}

void
layoutItem(int num){
	int i,j,k,x,y,maxx,maxy,miny;
	time_t tit;
	char tbuf[64];
	char ar,aw,ax;
	struct tm *date;

	curi=i=num;
	j=x=y=0;
	maxy=miny=1;
	maxx=0;

	clear();
	standout();
	move(0,0);
	for(k=0;k<XSIZE;k++){
		move(0,k);
		printw(" ");
	}

   /* draw headline */
	ar=aw=ax='-';
	if(arr[curi]->mode & READ_F) ar='r';
	if(arr[curi]->mode & WRIT_F) aw='w';
	if(arr[curi]->mode & EXEC_F) ax='x';

	tit = arr[curi]->ltime;
	date=localtime( &tit);
	strftime(tbuf, 32, "%y/%m/%d-%H:%M:%S", date);
	move(0,0);
	printw("%s(%03d/%03d) %c%c%c %02dx%02d  %s  %dline/%dbyte",
	  groupname,curi+1,maxinum,
	   ar,aw,ax,
		arr[curi]->width+3,
		arr[curi]->line+3,
		tbuf,
		arr[curi]->n,
		arr[curi]->b);


	if(retflag==1){
		for(k=1;k<9;k++){
			move(0,XSIZE-12+k);
			if(siori[k]!=0) addch('0'+k);
			else addch('-');
		}
	}
	if(yankb.id!=-1) {
		move(0,XSIZE-1);
		addch('*');
	}
	standend();

   /* draw window */
	while(1){
		if(maxx+(arr[i]->width)+2+wori<=XSIZE){
			if(miny+(arr[i]->line)+2+wori<=YSIZE){
				wins[j].it=arr[i];
				if(miny+(arr[i]->line)+2+wori>maxy)
					{ maxy=miny+(arr[i]->line)+2+wori; }
				drawWindow(j,maxx,miny,maxy);
				
				maxx+=(arr[i]->width)+2+wori;
			}else{
				break;
			}
		} else {
			maxx=0;
			miny=maxy;
			if(miny+(arr[i]->line)+2+wori<=YSIZE){
				wins[j].it=arr[i];
				maxy=miny+(arr[i]->line)+2+wori;
				drawWindow(j,0,miny,maxy);
				maxx+=(arr[i]->width)+2+wori;
			}else{
				break;
			}
		}
		i++;
		j++;
		if(maxinum==i)break;
	}
	maxw=j;
}

void
prompt(){
	int k;
	time_t tit;
	char tbuf[64];
	char ar,aw,ax;
	struct tm *date;

	mybox(curw,'=','|');
	standout();
	move(0,0);
	for(k=0;k<XSIZE;k++){
		move(0,k);
		printw(" ");
	}

	ar=aw=ax='-';
	if(arr[curi+curw]->mode & READ_F) ar='r';
	if(arr[curi+curw]->mode & WRIT_F) aw='w';
	if(arr[curi+curw]->mode & EXEC_F) ax='x';

	tit = arr[curi+curw]->ltime;
	date=localtime( &tit);
	strftime(tbuf, 32, "%y/%m/%d-%H:%M:%S", date);
	move(0,0);
	printw("%s(%03d/%03d) %c%c%c %02dx%02d  %s  %dline/%dbyte",
	groupname,curi+curw+1,maxinum,
		ar,aw,ax,
		arr[curi+curw]->width+3,
		arr[curi+curw]->line+3,
		tbuf,
		arr[curi+curw]->n,
		arr[curi+curw]->b) ;
	if(retflag==1){
		for(k=1;k<9;k++){
			move(0,XSIZE-14+k);
			if(siori[k]!=0) addch('0'+k);
			else addch('-');
		}
	}
	if(ok==0) {
		move(0,XSIZE-4);
		printw("OK");
		ok=-1;
	}
	if(yankb.id!=-1) {
		move(0,XSIZE-1);
		addch('*');
	}
	standend();
	refresh();
}

void
deprompt(){
	mybox(curw,'.',':');
}

next(){
	deprompt();
	if(curw < maxw-1) curw++;
	else{
		if(maxw+curi<maxinum){
			layoutItem(maxw+curi);
			curw=0;
		}
	}
	prompt();
}

void
prev(){
	deprompt();
	if(curw > 0) curw--;
	else{
		if(curi > 0) {
  	 		layoutItem(checklayout(curi));
			curw=maxw-1;
		}
	}
	prompt();
}

void
nextpage(){
	deprompt();
	if(curi+maxw<maxinum) {
			layoutItem(maxw+curi);
			curw=0;
	}
	prompt();
}

void
prevpage(){
	deprompt();
	if(curi > 0) {
  		layoutItem(checklayout(curi));
		curw=0;
	}
	prompt();
}

void
showpage(){
   char sh[BUFSIZ],tfn[16];
	FILE *tf;
	int curibk,curwbk;

	curibk=curi;
	curwbk=curw;

	strcpy(tfn,".kmvfXXXXXX");
	mkstemp(tfn);

	tf=fopen(tfn,"w");
	fprintf(tf,"%s",wins[curw].it->string);
	fclose(tf);


	nocbreak(); echo(); nl();
	clear(); refresh();
	
	sprintf(sh,"less %s",tfn);
	system(sh);

	unlink(tfn);
	cbreak(); noecho(); nonl();
	layoutItem(curibk);
	curw=curwbk;
	prompt();
}


void
editpage(){
   char sh[BUFSIZ],tfn[16],buf[STRSIZ],its[STRSIZ];
	FILE *tf;
	int curibk,curwbk,n,maxw;

	if(!(arr[curi+curw]->mode & WRIT_F)) return;

	curibk=curi;
	curwbk=curw;

	strcpy(tfn,".kmvfXXXXXX");
	mkstemp(tfn);
	tf=fopen(tfn,"w");
	fprintf(tf,"%s",wins[curw].it->string);
	fclose(tf);

	nocbreak(); echo(); nl();
	clear(); refresh();

	sprintf(sh,"%s %s",editor,tfn);
	system(sh);

	tf=fopen(tfn,"r");
	free(wins[curw].it->string);
	n=maxw=0;
	its[0]='\0';
	while(NULL != fgets(buf,BUFSIZ,tf)){
		if(maxw<strlen(buf)) maxw=strlen(buf);
		strcat(its,buf);
		n++;
	}
	wins[curw].it->string=strdup(its);
	wins[curw].it->ltime=time(NULL);
	wins[curw].it->w=maxw;
	wins[curw].it->n=n;
	wins[curw].it->b=strlen(its);
	fclose(tf);

	unlink(tfn);
	cbreak(); noecho(); nonl();
	layoutItem(curibk);
	curw=curwbk;
	prompt();
}

void
deletepage(){
	int i,bn;

	if(!(arr[curi+curw]->mode & WRIT_F)) return;

	if(maxinum!=1){
		deprompt();
		for(i=0;i<10;i++)
			if(arr[curi+curw]->id==siori[i]){siori[i]=0;}
		free(arr[curi+curw]->string);
		if(curi+curw==maxinum-1){
			if(curw==0) {
 				bn=checklayout(curi);
				free(arr[maxinum]);
				layoutItem(bn);
				maxinum--;
				curw=maxw-1;
				prompt();
			} else {
				free(arr[maxinum]);
				maxinum--;
				curw--;
				layoutItem(curi);
				prompt();
			}
		}else{
			maxinum--;
			for(i=curi+curw;i<maxinum;i++){
				copyItem(arr[i],arr[i+1]); free(arr[i+1]->string);
			}
			free(arr[maxinum]);
			layoutItem(curi);
			prompt();
		}
	}
	for(i=0;i<10;i++){
		if(siori[i]>maxinum-1) siori[i]=0;
	}
}

void
newpage(){
	int i;

	if(NULL==(item[maxinum]=malloc(sizeof(Item)))){
			fprintf(stderr,"no malloc4 \n"); exit(0); }

	for(i=maxinum;i>curi+curw;i--){
		copyItem(arr[i],arr[i-1]); free(arr[i-1]->string);
	}
	arr[curi+curw]->id=maxid;
	arr[curi+curw]->line=8;
	arr[curi+curw]->width=16;
	arr[curi+curw]->string=strdup("New\n");
	arr[curi+curw]->time=0;
	arr[curi+curw]->mode=6;
	arr[curi+curw]->ltime=time(NULL);
	maxid++;
	maxinum++;
	layoutItem(curi);
	prompt();
}

int
selectGroup(){
	WINDOW *osw,*isw;
	char c;
	int i,w,r,pos,f;

	r=-1;
	w=9;
	for(i=0;i<maxgnum;i++)
		if(strlen(group[i].name)>w) w=strlen(group[i].name);

	osw=newwin(maxgnum+3,w+3,(YSIZE-maxgnum-2)/2-1,(XSIZE-w-2)/2-1);

	for(i=0;i<maxgnum+3;i++){
		mvwaddch(osw,i,0,'|');
		mvwaddch(osw,i,w+2,'|');
	}
	for(i=0;i<w+3;i++){
		mvwaddch(osw,0,i,'=');
		mvwaddch(osw,maxgnum+2,i,'=');
	}

	isw=newwin(maxgnum+1,w+1,(YSIZE-maxgnum-2)/2,(XSIZE-w-2)/2);

	overwrite(osw,stdscr);
	overwrite(isw,stdscr);

	wmove(isw,0,0);
	wprintw(isw,">cancel");

	for(i=0;i<maxgnum;i++){
		wmove(isw,i+1,1);
		wprintw(isw,group[i].name);
	}
	refresh();
	wrefresh(isw);

	pos=0;
	f=1;
	while(f!=0){
		c = wgetch(isw);
		switch (c) {
			case 'j' : 
				if(pos<maxgnum){
					wmove(isw,pos,0);
					wprintw(isw," ");
					pos++;
					wmove(isw,pos,0);
					wprintw(isw,">");
					wrefresh(isw);
				}
				break;
			case 'k' : 
				if(pos>0){
					wmove(isw,pos,0);
					wprintw(isw," ");
					pos--;
					wmove(isw,pos,0);
					wprintw(isw,">");
				}
				wrefresh(isw);
				break;
			case '\r': 
			case ' ': 
				f=0;
				break;
		}
	}
	
	delwin(isw);
	delwin(osw);
	refresh();
	return pos-1;
}

void
changegroup(){
	int sg;

	deprompt();
	sg=selectGroup();
	if((sg!=-1)&&(sg!=curg)){
		writeItems(groupname);
		freeItems();
		curg=sg;
		curi=0;
		curw=0;
		readItems(group[curg].name);
	}
	layoutItem(curi);
	prompt();
	refresh();
}

int
creategroup(char *grnam){
	int newgrno;
	
	if(maxgnum==0) newgrno=0;
	else newgrno=maxgnum;

	strcpy(group[maxgnum].name,grnam);
	maxgnum++;

	crgrp = 1;
	return newgrno;
}

int
chk_group(char *grnam){
	int i,ngflag;

	ngflag=-1;
	for(i=0;i<maxgnum;i++){
		if(strcmp(group[i].name,grnam)==0) {
			ngflag=1;
		}
	}
	return ngflag;
}

void
inputLine(char *promptstr,char *ibuf){
	WINDOW *osw,*isw;
	char c;
	int i,w,r,pos,f;

	ibuf[0]='\0';

	osw = newwin(3,XSIZE*3/4,(YSIZE-3)/2,XSIZE/8);
	for(i=0;i<3;i++){ mvwaddch(osw,i,0,'|'); mvwaddch(osw,i,XSIZE*3/4-1,'|'); }
	for(i=0;i<XSIZE*3/4;i++){ mvwaddch(osw,0,i,'='); mvwaddch(osw,2,i,'='); }

	isw=newwin(1,XSIZE*3/4-2,(YSIZE-3)/2+1,XSIZE/8+1);

	overwrite(osw,stdscr);
	overwrite(isw,stdscr);

	wmove(isw,0,0);
	wprintw(isw,"%s : ",promptstr);
	refresh();
	wrefresh(isw);

	nocbreak(); echo(); nl();

   wgetnstr(isw,ibuf,BUFSIZ);

	cbreak(); noecho(); nonl();
	refresh();
	wrefresh(isw);
	
	delwin(isw);
	delwin(osw);
	refresh();
}

void
newgroup(){
	char ibuf[BUFSIZ];
	int newgrno;

	inputLine("New groupname",ibuf);

	if((strlen(ibuf)<1)||(strlen(ibuf)>MAXGNLTH)) {
		layoutItem(curi);
		prompt();
		refresh();
		return;
	}

	if(chk_group(ibuf)==-1){
		newgrno=creategroup(ibuf);
		writeItems(groupname);
		freeItems();
		curg=newgrno;
		curi=0;
		curw=0;
		readItems(group[curg].name);
	}
	layoutItem(curi);
	prompt();
	refresh();
}

void
moveitem(){
	FILE *fp;
	int sg;
	char buf[128];

	if(!(arr[curi+curw]->mode & WRIT_F)) return;

	if(maxinum>1){
		sg=selectGroup();
		if((sg!=-1)&&(sg!=curg)){
			sprintf(buf,"%s/%s",rootDir,group[sg].name);
			if(NULL==(fp=fopen(buf,"a"))){
				fprintf(stderr,"%s not found\n",buf); exit(0);}
			fprintf(fp,"%s",wins[curw].it->string);
			fprintf(fp,"%s",SEPA);
			fprintf(fp,"%d %d %d %d %d\n", wins[curw].it->width, wins[curw].it->line,wins[curw].it->time, wins[curw].it->ltime, wins[curw].it->mode);
			fclose(fp);
			deletepage();	
		}else{
			layoutItem(curi);
			prompt();
			refresh();
		}
	}
}

void
uppage(){
	deprompt();

	if(curw==0){
		if(curi!=0){
			swapItem(arr[curi],arr[curi-1]);
			layoutItem(checklayout(curi));
			curw=maxw-1;
			prompt();
		}
	}else{
		swapItem(arr[curi+curw],arr[curi+curw-1]);
		curw--;
  		layoutItem(curi);
		prompt();
	}
}

void
downpage(){
	deprompt();

	if(curw == maxw-1) {
		if(maxw+curi<maxinum){
			swapItem(arr[curi+curw],arr[curi+curw+1]);
			curi+=maxw;
			curw=0;
			layoutItem(curi);
			prompt();
		}
	} else{
		swapItem(arr[curi+curw],arr[curi+curw+1]);
		curw++;
  		layoutItem(curi);
		prompt();
	}

}

void
toppage(){
	int i;
	Item tmp;

	if(curi+curw!=0){
		copyItem(&tmp,arr[curi+curw]); free(arr[curi+curw]->string);

		for(i=curi+curw;i>0;i--){
			copyItem(arr[i],arr[i-1]); free(arr[i-1]->string);
		}

		copyItem(arr[0],&tmp); free(tmp.string);
		curi=0;curw=0;
		deprompt();
		layoutItem(curi);
		prompt();
	}
}

void
bottompage(){
	int i;
	Item tmp;

	if(curi+curw!=maxinum-1){
		copyItem(&tmp,arr[curi+curw]); free(arr[curi+curw]->string);

		for(i=curi+curw;i<maxinum-1;i++){
			copyItem(arr[i],arr[i+1]); free(arr[i+1]->string);
		}
		copyItem(arr[maxinum-1],&tmp); free(tmp.string);
		deprompt();
		layoutItem(curi);
		prompt();
	}
}

void
incline(){
	deprompt();

	if (arr[curw+curi]->line < YSIZE-4){
		(arr[curw+curi]->line)++;
		if(arr[curw+curi]->line+wins[curw].y >= YSIZE-3){
			curi=curw+curi;
			curw=0;
		}
	}
 	layoutItem(curi);
	prompt();

}

void
decline(){
	deprompt();

	if (arr[curw+curi]->line> 0){
		(arr[curw+curi]->line)--;
	}
 	layoutItem(curi);
	prompt();
}

void
incwidth(){
	deprompt();

	if (arr[curw+curi]->width < XSIZE-2){
		(arr[curw+curi]->width)++;
		if((arr[curw+curi]->line)+wins[curw].maxy+1 >= YSIZE){
			if( arr[curw+curi]->width+wins[curw].x+2 >= XSIZE) {
				curi=curw+curi;
				curw=0;
			}
		}
	}
 	layoutItem(curi);
	prompt();
}

void
decwidth(){
	deprompt();

	if (arr[curw+curi]->width > 10)
			(arr[curw+curi]->width)--;
 	layoutItem(curi);
	prompt();
}

void
incwidth10(){
	deprompt();

	if (arr[curw+curi]->width < XSIZE-2){
		(arr[curw+curi]->width)+=10;
		if (arr[curw+curi]->width > XSIZE-2) arr[curw+curi]->width = XSIZE-2;
		if((arr[curw+curi]->line)+wins[curw].maxy+1 >= YSIZE){
			if( arr[curw+curi]->width+wins[curw].x+2 >= XSIZE) {
				curi=curw+curi;
				curw=0;
			}
		}
 		layoutItem(curi);
	}
	prompt();
}

void
decwidth10(){
	deprompt();

	if (arr[curw+curi]->width > 10){
		(arr[curw+curi]->width)-=10;
		if (arr[curw+curi]->width < 10) arr[curw+curi]->width  =10;
 		layoutItem(curi);
	}
	prompt();
}




int
retrieve_data(char *key){
	char buf[STRSIZ];
	int i,j,k,l,len;

	l=0;
	for(i=0;i<maxinum;i++){
		len=strlen(item[i]->string);
		k=0;
		for(j=0;j<len;j++){
			if((item[i]->string)[j]!='\n'){
				buf[k]=(item[i]->string)[j];
				k++;
			}
		} 
		buf[k]='\0';

		if(NULL!=strstr(buf,key)){
			view[l]=item[i];
			l++;
		}
	}
	return l;
}

int ltime_cmp(const Item *a, const Item *b)
{
	if (a->ltime < b->ltime) return (-1);
	else if (a->ltime > b->ltime) return (1);
	return (0);
}

sortdata(int mode){
	int i,j;
	Item *sw;

	for(i=0;i<maxinum;i++) view[i]=item[i];

	for(i=0;i<maxinum-1;i++){
		for(j=maxinum-1;j>i;j--){
			if(mode==TIMEATTR){
				if(view[j]->time > view[j-1]->time){
					sw=view[j];
					view[j]=view[j-1];
					view[j-1]=sw;
				}
			} else if(mode==LASTTIME){
				if(view[j]->ltime > view[j-1]->ltime){
					sw=view[j];
					view[j]=view[j-1];
					view[j-1]=sw;
				}
			} else if(mode==ALPHA){
				if(0>strcmp(view[j]->string,view[j-1]->string)){
					sw=view[j];
					view[j]=view[j-1];
					view[j-1]=sw;
				}
			}
		}
	}

}

void
help(char *helps1,char *helps2){
   char sh[BUFSIZ],tfn[16];
	FILE *tf;

	strcpy(tfn,".kmvfXXXXXX");
	mkstemp(tfn);

	tf=fopen(tfn,"w");
	if(helps2==NULL) fprintf(tf,"%s",helps1);
	else fprintf(tf,"%s%s",helps1,helps2);
	fclose(tf);

	nocbreak(); echo(); nl();
	clear(); refresh();
	sprintf(sh,"less %s",tfn);
	system(sh);

	unlink(tfn);
	cbreak(); noecho(); nonl();
	layoutItem(curi);
	prompt();
}

void help_all(){
	help(helpall1,helpall2);
}

void help_sort(){
	help(helpsort,NULL);
}

void
jump(int num){
	int i,x;

	if(num==0){
		curi=0;
		curw=0;
		layoutItem(curi);
		prompt();
	} else if(siori[num]!=0){
		x=0;
		for(i=0;i<maxinum;i++){
			if(arr[i]->id == siori[num]) x=i; 
		}
		curi=x;
		curw=0;
		layoutItem(curi);
		prompt();
	}
}

void
toggleoverride(){
	if(wori==0) wori=1; else wori=0;
	jump(0);
}

void
retrieve(int mode){
	char buf[BUFSIZ],gnbak[64];
	int i,rn,curibak,curwbak,maxwbak,maxinumbak;
	char c;

	retflag=0;
	strcpy(gnbak,groupname);

	if(mode==RETRIEVE){
		sgets(buf,BUFSIZ,item[curi+curw]->string);
		rn= retrieve_data(buf);
		sprintf(groupname,"<retrieve (%s)> %d",gnbak,rn);
	} else if((mode==TIMEATTR)||(mode==LASTTIME)||(mode==ALPHA)){
		rn=maxinum;
		if(mode==TIMEATTR){
			sprintf(groupname,"<time sort(%s)>",gnbak);
		} else if(mode==LASTTIME){
			sprintf(groupname,"<ltime sort(%s)>",gnbak);
		} else if(mode==ALPHA){
			sprintf(groupname,"<dic sort(%s)>",gnbak);
		}
		sortdata(mode);
	}

	curibak=curi;
	curwbak=curw;
	maxwbak=maxw;
	maxinumbak=maxinum;

	arr=view;
	curi=0;
	curw=0;
	maxinum=rn;

   layoutItem(0);
	prompt();
	while('q' != (c = mygetch())){
		switch (c) {
			case 'j' : 
			case 'z' : 
			case CURDOWN : 
			case F2 : 
				next();break;
			case 'k': 
			case 'a': 
			case CURUP : 
			case F1 : 
				prev();break;
			case 'n' : 
			case ']' : 
			case PgDOWN : 
				nextpage();break;
			case 'p' : 
			case '[' : 
			case PgUP : 
				prevpage();break;
			case '\r' : 
			case ' ' : 
			case F3 : 
				showpage();break;
			case 'v' : 
			case 'e' : 
				editpage();break;
			case 'o' : 
				toggleoverride();break;
			case 'Y' : yank();break;
			case 'Z' : 
				if((mode==TIMEATTR)||(mode==LASTTIME)||(mode==ALPHA)){
					for(i=0;i<maxinum;i++) item[i]=view[i];
				}
				ok=0;prompt();
			break;
			case '?' : help_sort();break;
		}
	}
	curi=curibak;
	curw=curwbak;
	maxw=maxwbak;
	maxinum=maxinumbak;
	strcpy(groupname,gnbak);

	arr=item;
	retflag=1;
   layoutItem(curi);
	prompt();
}

void
settimevalue(){
	WINDOW *osw,*isw;
	char ibuf[12];
	int i;

	osw=newwin(3,12,(YSIZE-3)/2-1,(XSIZE-12)/2-1);

	for(i=0;i<3;i++){
		mvwaddch(osw,i,0,'|');
		mvwaddch(osw,i,11,'|');
	}
	for(i=0;i<12;i++){
		mvwaddch(osw,0,i,'=');
		mvwaddch(osw,2,i,'=');
	}

	isw=newwin(1,10,(YSIZE-3)/2,(XSIZE-12)/2);

	overwrite(osw,stdscr);
	overwrite(isw,stdscr);

	wmove(isw,0,0);
	echo(); 
	refresh();
	wrefresh(isw);
   wgetstr(isw,ibuf);
	noecho();
	refresh();
	wrefresh(isw);

	if(strlen(ibuf)<7) 
		arr[curw+curi]->time = 0;
	else 
		arr[curw+curi]->time = atoi(ibuf);

	arr[curw+curi]->ltime = time(NULL);
	
	delwin(isw);
	delwin(osw);
   layoutItem(curi);
	prompt();
}

void
duplicate(){
	int i;

	if(NULL==(item[maxinum]=malloc(sizeof(Item)))){
			fprintf(stderr,"no malloc4 \n"); exit(0); }

	for(i=maxinum;i>curi+curw;i--){
		copyItem(arr[i],arr[i-1]); 
	}
	arr[i]->id=maxid;
	maxid++;
	maxinum++;
	layoutItem(curi);
	prompt();
}

void
concat(){
	char buf[STRSIZ];

	if(!(arr[curi+curw]->mode & WRIT_F)) return;

	if(curi+curw < maxinum-1){
		if(STRSIZ - 5 > 
			strlen(arr[curi+curw]->string)+strlen(arr[curi+curw+1]->string)){

			strcpy(buf,arr[curi+curw]->string);
			strcat(buf,SEPA2);
			strcat(buf,arr[curi+curw+1]->string);
			free(arr[curi+curw+1]->string);
			copyItem(arr[curi+curw+1],arr[curi+curw]);free(arr[curi+curw]->string);
			arr[curi+curw+1]->string=strdup(buf);
			deletepage();
		}
	}
}


void
setjump(int num){
	int i;

	for(i=1;i<10;i++)
		if(siori[i]==arr[curi+curw]->id) siori[i]=0;
	if(num!=0)
		siori[num]=arr[curi+curw]->id;
	layoutItem(curi);
	ok=0;prompt();
}

yank(){
	copyItem(&yankb,arr[curi+curw]); 
	ok=0;prompt();
}

put(){
	int i;

	if(yankb.id!=-1){
		if(NULL==(item[maxinum]=malloc(sizeof(Item)))){
			fprintf(stderr,"no malloc4 \n"); exit(0); }

		for(i=maxinum;i>curi+curw;i--){
			copyItem(arr[i],arr[i-1]); free(arr[i-1]->string);
		}
		copyItem(arr[curi+curw],&yankb); 
		arr[curi+curw]->id=maxid;
		maxid++;
		maxinum++;
		arr[curi+curw]->ltime=time(NULL);
		layoutItem(curi);
		prompt();
	}
}

void
chattr(int att){
	if(att == WRIT_F){
		if(!(arr[curi+curw]->mode & WRIT_F)) {
			arr[curi+curw]->mode |= WRIT_F;
		}else{
			arr[curi+curw]->mode &= (~WRIT_F);
		}
	}
	if(att == EXEC_F){
		if(!(arr[curi+curw]->mode & EXEC_F)) {
			arr[curi+curw]->mode |= EXEC_F;
		}else{
			arr[curi+curw]->mode &= (~EXEC_F);
		}
	}

	layoutItem(curi);
	ok=0;prompt();
}

void
executeItem(){
   char sh[BUFSIZ],tfn[16];
	FILE *tf;
	int curibk,curwbk;

	if(!(arr[curi+curw]->mode & EXEC_F)) return;

	curibk=curi;
	curwbk=curw;

	strcpy(tfn,".kmvfXXXXXX");
	mkstemp(tfn);

	tf=fopen(tfn,"w");
	fprintf(tf,"%s",wins[curw].it->string);
	fclose(tf);

	nocbreak(); echo(); nl();
	clear(); refresh();
	
	sprintf(sh,"csh %s",tfn);
	system(sh);

	unlink(tfn);
	cbreak(); noecho(); nonl();
	layoutItem(curibk);
	curw=curwbk;
	prompt();
}


void
eventLoop(){
	char c;

	curi=0;
	arr=item;
   layoutItem(0);
	prompt();
	while('q' != (c = mygetch())){
		switch (c) {
			case 'j' : 
			case 'z' : 
			case CURDOWN : 
			case F2 : 
				next();break;
			case 'k': 
			case 'a': 
			case CURUP : 
			case F1 : 
				prev();break;
			case 'n' : 
			case ']' : 
			case PgDOWN : 
				nextpage();break;
			case 'p' : 
			case '[' : 
			case PgUP : 
				prevpage();break;
			case '\r' : 
			case ' ' : 
			case F3 : 
				showpage();break;
			case 'v' : 
			case 'e' : 
				editpage();break;
			case 'o' : 
				toggleoverride();break;
			case 'R' : deletepage();break;
			case 'W' : 
				writeItems(groupname);
				ok=0; prompt();
				break;
			case 'X' : winEnd(); delLock(); exit(0);break;
			case 'N' : newpage();break;
			case 'G' : changegroup();break;
			case 'M' : moveitem();break;
			case 'U' : uppage();break;
			case 'D' : downpage();break;
			case '<' : toppage();break;
			case '>' : bottompage();break;
			case 'H' : decwidth();break;
			case 'J' : incline();break;
			case 'K' : decline();break;
			case 'L' : incwidth();break;
			case '{': decwidth10();break;
			case '}': incwidth10();break;
			case '/' : retrieve(RETRIEVE);break;
			case 'C' : duplicate();break;
			case 'B' : newgroup();break;
			case 'T' : settimevalue();break;
			case 's' : retrieve(ALPHA);break;
			case 'l' : retrieve(LASTTIME);break;
			case 't' : retrieve(TIMEATTR);break;
			case '' : chattr(WRIT_F);break;
			case '' : chattr(EXEC_F);break;
			case 'E' : executeItem();break;
			case '+' : concat();break;
			case '0' : jump(0);break;
			case '1' : jump(1);break;
			case '2' : jump(2);break;
			case '3' : jump(3);break;
			case '4' : jump(4);break;
			case '5' : jump(5);break;
			case '6' : jump(6);break;
			case '7' : jump(7);break;
			case '8' : jump(8);break;
			case '9' : jump(9);break;
			case SHIFT0 : setjump(0);break;
			case SHIFT1 : setjump(1);break;
			case SHIFT2 : setjump(2);break;
			case SHIFT3 : setjump(3);break;
			case SHIFT4 : setjump(4);break;
			case SHIFT5 : setjump(5);break;
			case SHIFT6 : setjump(6);break;
			case SHIFT7 : setjump(7);break;
			case SHIFT8 : setjump(8);break;
			case SHIFT9 : setjump(9);break;
			case 'Y' : yank();break;
			case 'P' : put();break;
			case '?' : help_all();break;
		}
	}
}

int
main(int ac,char *av[]){
	if(ac!=2){
		fprintf(stderr,"%s dirname\n",av[0]);
		exit(1);
	}
	editor = getenv("EDITOR");

	yankb.string=ybstr;
	yankb.id=-1;

	crLock();
	rootDir=av[1];
	getGroup();
	readItems("base");
	winInit();
	eventLoop();
	writeItems(groupname);
	winEnd();
	delLock();

	return 0;
}
